
//   X-PONG    //

// compila solo sotto GCC in GNU/Linux
// richiede Svgalib

// bug da risolvere e aggiunte:
// 1) collisione della pallina per i player 3 e 4 errata
// 2) scelta casuale dell'angolo di partenza della pallina da rivedere; qualche volta parte in verticale!
// 3) scritte di vittoria finale assenti
// 4) tiro ad effetto mancante

#include<stdio.h>
#include<vgamouse.h>
#include<vga.h>
#include<math.h>
#include<vgakeyboard.h>
#include<time.h>

FILE*data;  // file generico

// puntatori per la grafica //

unsigned char *screen;                         // buffer video
unsigned char *palv;                           // vettore paletta grafica RGB
unsigned char *ball,*bigball,*bgbigball;       // sprite pallina
unsigned char *bar;                            // sprite barre dei giocatori
unsigned char *bgball;                         // sfondo dello sprite pallina
unsigned char *bgbar1,*bgbar2,*bgbar3,*bgbar4; // sfondo dello sprite barre dei giocatori
unsigned char *header;                         // barra superiore dei punteggi
unsigned char ct,s1,s2;                        // il colore trasparente,sfondo 1e2
unsigned char *t1,*t2,*t3,*t4,*tgo;            // scritte 1,2,3,4,go!
unsigned char *bgt;                            // sfondo scritte
unsigned char *key_vector;                     // vettore per scancode della tastiera

int position(long int pos) // posizione nel file
{
	fseek(data,pos,SEEK_SET);
}

fade_out(void)     // oscura lo schermo sino al nero
{
	unsigned int R,G,B;  // colori RGB
	int t,w;
	
	for(w=0;w<64;w++)
	{
		for (t=0;t<256;t++)
		{
			vga_getpalette(t,&R,&G,&B);
			if (R>0) R--; else R=0;
			if (G>0) G--; else G=0;
			if (B>0) B--; else B=0;
			vga_setpalette(t,R,G,B);
		}
	}
}

int allocazione_memoria()     // creazione dello spazio di memoria per gli elementi grafici
{
	screen=(unsigned char*)malloc(64000*sizeof(unsigned char));
	bar=(unsigned char*)malloc(210*sizeof(unsigned char));
	bgbar1=(unsigned char*)malloc(210*sizeof(unsigned char));
	bgbar2=(unsigned char*)malloc(210*sizeof(unsigned char));
	bgbar3=(unsigned char*)malloc(210*sizeof(unsigned char));
	bgbar4=(unsigned char*)malloc(210*sizeof(unsigned char));
	bgball=(unsigned char*)malloc(25*sizeof(unsigned char));
	palv=(unsigned char*)malloc(768*sizeof(unsigned char));
	ball=(unsigned char*)malloc(25*sizeof(unsigned char));
	header=(unsigned char*)malloc(8320*sizeof(unsigned char));
	t4=(unsigned char*)malloc(20*34*sizeof(unsigned char));
	t3=(unsigned char*)malloc(20*34*sizeof(unsigned char));
	t2=(unsigned char*)malloc(20*34*sizeof(unsigned char));
	t1=(unsigned char*)malloc(20*34*sizeof(unsigned char));
	tgo=(unsigned char*)malloc(62*34*sizeof(unsigned char));
	bigball=(unsigned char*)malloc(11*11*sizeof(unsigned char));
	bgbigball=(unsigned char*)malloc(11*11*sizeof(unsigned char));
	bgt=(unsigned char*)malloc(62*34*sizeof(unsigned char));
}

int load_sprite(int rel_posx,int rel_posy,int dimx,int dimy,unsigned char*data) // carica uno sprite
{
	int y,x;
	
	for(y=0;y<dimy;y++)
	{
		for(x=0;x<dimx;x++) data[x+y*dimx]=vga_getpixel(x+rel_posx+1,y+rel_posy+1);
	}
}

int load_sprites(void) // carica in memoria tutti gli sprites
{
	if ((data=fopen("sprites8bit.bmp","rb"))==0)
	{
		exit(0);
	}
	load_palette_from_file();
	hardreset_palette();
	load_screen();
	fclose(data);
	vga_drawscansegment(screen,0,0,64000);
	ct=vga_getpixel(8+1,0+1);       // carica il colore trasparente
	s1=vga_getpixel(26+1,16+1);
	s2=vga_getpixel(114+5+1,2+3+1);
	load_sprite(0,39,320,26,header);  // testata dei punteggi
	load_sprite(47,3,5,5,ball);       // pallina piccola
	load_sprite(0,0,7,30,bar);        // barra
	load_sprite(192,2,20,34,t1);      // 1..
	load_sprite(168,2,20,34,t2);      // 2..
	load_sprite(144,2,20,34,t3);      // 3..
	load_sprite(282,2,20,34,t4);      // 4..
	load_sprite(216,2,62,34,tgo);     // go!..
	load_sprite(25,0,11,11,bigball);       // pallina grande
}

draw_sprite(int x,int y,int dimx,int dimy,char*data,char tc) // disegna lo sprite ROUTINE UN PO' TROPPO LENTA //
{
	int t,w,tmp;
	
	for(w=0;w<dimy;w++)
	{
		tmp=w*dimx;
		for(t=0;t<dimx;t++)
		{
			vga_setcolor(data[t+tmp]);
			if (data[t+tmp]!=tc)
				vga_drawpixel(x+t,y+w);
		}
	}
}

save_bg(int x,int y,int dimx,int dimy,char*data) // salva lo sfondo dello sprite corrente //
{
	int t,w,tmp;
	for(w=0;w<dimy;w++)
	{
		tmp=w*dimx;
		for(t=0;t<dimx;t++)
		{
			data[t+tmp]=vga_getpixel(x+t,y+w);
		}
	}
}

fade_in(void)       // riporta lo schermo dal nero alla paletta corrente
{
	unsigned int R,G,B;  // colori RGB
	int t,w;

	hardreset_palette();
	for(w=0;w<64;w++)
	{
		for (t=0;t<256;t++)
		{
			vga_getpalette(t,&R,&G,&B);
			if (R<palv[3*t+0]) R++;
			if (G<palv[3*t+1]) G++;
			if (B<palv[3*t+2]) B++;
			vga_setpalette(t,R,G,B);
		}
	}
}

int load_palette_from_file(void) // caricamento paletta grafica
{
	unsigned char R,G,B;  // colori RGB
	int i;

	position(54);      // salta l'header del file BMP
	for (i=0;i<256;i++)
	{
		B=fgetc(data);
		G=fgetc(data);
		R=fgetc(data);
		fgetc(data);
		palv[3*i+0]=R/4;    // setta il vettore dei colori
		palv[3*i+1]=G/4;
		palv[3*i+2]=B/4;
	}
}

int set_palette(void)   // setta la paletta corrente
{
	unsigned char R,G,B;  // colori RGB
	int i;

	for (i=0;i<256;i++)
	{
		vga_setpalette(i,(int)palv[3*i+0],(int)palv[3*i+1],(int)palv[3*i+2]); // scrive la VGA
	}
}

int hardreset_palette(void)  // resetta la paletta corrente
{
	unsigned char R,G,B;  // colori RGB
	int i;

	for (i=0;i<256;i++) vga_setpalette(i,0,0,0); // scrive la VGA
}

int load_screen(void)   // carica una schermata 320x200x8 dal file corrente
{
	long int x,y;
	
	unsigned char tmp[320];
	position(1077);
	for(x=0;x<64000;x++) screen[x]=fgetc(data);
	for(y=1;y<100;y++)   // flip
	{
		for(x=0;x<320;x++) tmp[x]=screen[x+y*320];
		for(x=0;x<320;x++) screen[x+y*320]=screen[x+(200-y)*320];
		for(x=0;x<320;x++) screen[x+(200-y)*320]=tmp[x];
	}
}

int flush_screen(void)    // resetta il buffer video
{
	long int x;

	for(x=0;x<64000;x++) screen[x]=0;
	vga_drawscansegment(screen,0,0,64000);
}

void loading(void)       // schermata del loading
{
	if ((data=fopen("loading.bmp","rb"))==0)
	{
		exit(0);
	}
	load_palette_from_file();
	set_palette();
	hardreset_palette();
	load_screen();
	fclose(data);
	vga_drawscansegment(screen,0,0,64000);
	fade_in();
	sleep(3);
	fade_out();
	flush_screen();
}

int maintitle(void)    // mostra il maintitle + menu iniziale
{	
	int x,y,state,key;
	if ((data=fopen("maintitle.bmp","rb"))==0)
	{
		exit(0);
	}
	load_palette_from_file();
	set_palette();
	load_screen();
	fclose(data);
	hardreset_palette();
	vga_drawscansegment(screen,0,0,64000);
	fade_in();
	load_sprite(153,36,11,11,bigball);       // pallina grande
	save_bg(60,100,11,11,bgbigball);
	ct=vga_getpixel(153+1,36+1);       // carica il colore trasparente
	state=0;
	x=60;
	y=100;
	keyboard_close();
	while(1)
	{                           // loop per il menu principale
		draw_sprite(x,y,11,11,bgbigball,1);
		draw_sprite(320-x,y,11,11,bgbigball,1);
		if (state==0) {x=60;y=100;}
		if (state==1) {x=75;y=123;}
		if (state==2) {x=70;y=147;}
		if (state==3) {x=110;y=171;}
		save_bg(x,y,11,11,bgbigball);
		draw_sprite(x,y,11,11,bigball,ct);
		draw_sprite(320-x,y,11,11,bigball,ct);
		usleep(1000*100);
		key=vga_getch();
		if (key=='q') state--;
		if (key=='a') state++;
		if (state==-1) state=3;
		if (key==0x0A) {fade_out();return(state);}
		state=state%4;
	}
}

int background_draw(int color1,int color2) // disegna lo sfondo a quadretti
{
	int t,w,z;

	for(z=0;z<25;z++)
	{
		for(w=0;w<4;w++) for(t=0;t<320;t++) {if (t%8<4) screen[t+320*w+320*8*z]=color1; else screen[t+320*w+320*8*z]=color2;}
		for(w=0;w<4;w++) for(t=0;t<320;t++) {if (t%8>=4) screen[t+320*w+320*4+320*8*z]=color1; else screen[t+320*w+320*4+320*8*z]=color2;}
	}
	vga_drawscansegment(screen,0,0,64000);
}

int mouse_load()          // setta il mouse
{
	mouse_init("/dev/mouse",5,150);
	mouse_setposition(0,100);
	mouse_setyrange(0+26+15,200-15);
	mouse_setscale(100);
	mouse_setwrap(0);
}

void mousestatus(int *y,int *button)
{
	mouse_update();
	*y=mouse_gety();
	*button=mouse_getbutton();
}

int punteggio(int score1,int score2)
{
	int x;

	for(x=0;x<score1;x++) {draw_sprite(20+x*14,7,11,11,bigball,ct);};
	for(x=0;x<score2;x++) {draw_sprite(320-31-x*14,7,11,11,bigball,ct);};
}

float radius_rnd(float pi)
{
	float tmp;
	tmp=pi*rand()/32768;
	tmp=-tmp;
	return(tmp);
}

unsigned int cpuIA(float radius,int x,int y,int p1y,int p2y)    // calcolo mossa del computer
{
	if ((y>=26+15) && (y<=200-15)) {return(y);}
	else return(p2y);
}

int game(int *score1,int *score2,int state,int velocita)        // routine principale del pong
{
	// variabili di gioco
	double radius;          // versore direzione+velocita
	double fx,fy;           // posizione reale della pallina
	double pi=3.14159;      // pigreco
	unsigned int x,y;       // posizione su schermo della pallina
	unsigned int p1y,p2y,p3y,p4y;   // posizioni giocatori

	int button;

	p1y=100;
	p2y=100;
	p3y=100;
	p4y=100;
	fx=160;  // pallina in posizione centrale
	fy=100;
	radius=radius_rnd(pi);
	background_draw(s1,s2);

	draw_sprite(0,0,320,26,header,ct);

	save_bg(x-2,y-2,5,5,bgball);
	save_bg(10,p1y-15,7,30,bgbar1);
	save_bg(303,p2y-15,7,30,bgbar2);

	if (state==2)
	{
		save_bg(10+30,p3y-15,7,30,bgbar3);
		save_bg(303-30,p4y-15,7,30,bgbar4);
	}

	punteggio(*score1,*score2);

	while (1)
	{
		draw_sprite(x-2,y-2,5,5,bgball,ct);
		draw_sprite(10,p1y-15,7,30,bgbar1,ct);
		draw_sprite(303,p2y-15,7,30,bgbar2,ct);

		if (state==2)
		{
			draw_sprite(10+30,p3y-15,7,30,bgbar3,ct);
			draw_sprite(303-30,p4y-15,7,30,bgbar4,ct);
		}

		fx=(fx+cos(radius)*velocita); // aggiornamento posizione pallina
		fy=(fy-sin(radius)*velocita);
		x=(unsigned int)fx;
		y=(unsigned int)fy;

		// eventi per la pallina //

		if ((fy<=27) || (fy>=200-2)) radius=-radius;   // rimbalzo laterale
		if (fx<=0+2+2)   {(*score2)++;return(0);}                         // vittoria dx
		if (fx>=320-2-1) {(*score1)++;return(0);}                         // vittoria sx
		if ((p1y-15<fy) && (p1y+15>fy) && (x<20) && (cos(radius)<0) ) {radius=pi-radius+((p1y-fy)/60);};
		if ((p2y-15<fy) && (p2y+15>fy) && (x>320-20) && (cos(radius)>0) ) {radius=pi-radius-((p2y-fy)/60);};
		if (state==2)
		{
			if ((p3y-15<fy) && (p3y+15>fy) && (x<20+30) && (cos(radius)<0) ) {radius=pi-radius+((p3y-fy)/60);};
			if ((p3y-15<fy) && (p3y+15>fy) && (x<20+30-3) && (cos(radius)>0) ) {radius=pi-radius;};
			if ((p4y-15<fy) && (p4y+15>fy) && (x>320-20-30) && (cos(radius)>0) ) {radius=pi-radius-((p4y-fy)/60);};
			if ((p4y-15<fy) && (p4y+15>fy) && (x>320-20-30+3) && (cos(radius)<0) ) {radius=pi-radius;};
		}

	// scansione della tastiera e del mouse //

	keyboard_update();
	key_vector=keyboard_getstate();

	if (state==2)
	{
		if (key_vector[38]==1) {if (p2y<200-15) p2y=p2y+4;}     // L
		if (key_vector[25]==1) {if (p2y>26+15+2)  p2y=p2y-4;}   // P
		if (key_vector[30]==1) {if (p1y<200-15) p1y=p1y+4;}     // A
		if (key_vector[16]==1) {if (p1y>26+15+2)  p1y=p1y-4;}   // Q
		if (key_vector[46]==1) {if (p3y<200-15) p3y=p3y+4;}     // C
		if (key_vector[32]==1) {if (p3y>26+15+2)  p3y=p3y-4;}   // D
		if (key_vector[49]==1) {if (p4y<200-15) p4y=p4y+4;}     // N
		if (key_vector[36]==1) {if (p4y>26+15+2)  p4y=p4y-4;}   // J
	}
	if (state==1)
	{
		if (key_vector[38]==1) {if (p2y<200-15) p2y=p2y+4;}     // L
		if (key_vector[25]==1) {if (p2y>26+15+2)  p2y=p2y-4;}   // P
		if (key_vector[30]==1) {if (p1y<200-15) p1y=p1y+4;}     // A
		if (key_vector[16]==1) {if (p1y>26+15+2)  p1y=p1y-4;}   // Q
	}

	if (state==0)
	{
		p2y=cpuIA(radius,x,y,p1y,p2y);  // mossa del computer
		mousestatus(&p1y,&button);  // mossa del giocatore
	}

	save_bg(x-2,y-2,5,5,bgball);
	save_bg(10,p1y-15,7,30,bgbar1);
	save_bg(303,p2y-15,7,30,bgbar2);

	if (state==2)
	{
		save_bg(10+30,p3y-15,7,30,bgbar3);
		save_bg(303-30,p4y-15,7,30,bgbar4);
	}

	draw_sprite(x-2,y-2,5,5,ball,ct);
	draw_sprite(10,p1y-15,7,30,bar,ct);
	draw_sprite(303,p2y-15,7,30,bar,ct);

	if (state==2)
	{	
		draw_sprite(10+30,p3y-15,7,30,bar,ct);
		draw_sprite(303-30,p4y-15,7,30,bar,ct);
	}

	vga_waitretrace();
	}
}

int main(void)
{
	int score1,score2,state; // puteggi dei giocatori + modo

	vga_setmode(5);    // entra in modo 320x200x256
	sleep(3);
	allocazione_memoria();
	loading();
	keyboard_init();
	while ((state=maintitle())!=3) 
	{
		load_sprites();
		flush_screen();
		set_palette();
		keyboard_init();
		mouse_load();
		score1=0;
		score2=0;
		hardreset_palette();
		background_draw(s1,s2);
		draw_sprite(0,0,320,26,header,ct);
		draw_sprite(10,100-15,7,30,bar,ct);
		draw_sprite(303,100-15,7,30,bar,ct);
		if (state==2)
		{
			draw_sprite(10+30,100-15,7,30,bar,ct);
			draw_sprite(303-30,100-15,7,30,bar,ct);
		}
		fade_in();
		sleep(3);      // conto alla rovescia //
		save_bg(160-32,100-17,62,34,bgt);
		draw_sprite(160-10,100-17,20,34,t3,ct);
		usleep(1000*500);
		draw_sprite(160-32,100-17,62,34,bgt,ct);
		draw_sprite(160-10,100-17,20,34,t2,ct);
		usleep(1000*500);
		draw_sprite(160-32,100-17,62,34,bgt,ct);
		draw_sprite(160-10,100-17,20,34,t1,ct);
		usleep(1000*500);
		draw_sprite(160-32,100-17,62,34,bgt,ct);
		draw_sprite(160-32,100-17,62,34,tgo,ct);
		usleep(1000*500);
		srand((unsigned int)time(NULL));     // seed per il generatore random
		do
		{
			if ((score1!=0) || (score2!=0)) fade_in();
			game(&score1,&score2,state,5);
			fade_out();
			usleep(1000*300);
		}
		while ((score1<6) && (score2<6));
		keyboard_close();
	}
	fade_out();
	vga_setmode(0); // rientra in modo testo
	exit(0);
}